import numpy as np
import matplotlib.pyplot as plt
from time import perf_counter_ns

h = float(input("Ingrese la altura desde la cual se suelta la servilleta (en metros): "))
m = float(input("Ingrese la masa de la servilleta (en kilogramos): "))
area = float(input("Ingrese el área del objeto que cae (en metros cuadrados): "))

g = 9.8

ti_inicial = perf_counter_ns()

def sinfriccion(h, m):
    vf = 0
    tiempo = 0
    distanciarecorrida = 0
    delta_t = 0.001
    
    tiempos1 = []
    velocidades1 = []
    distancias1 = []
    
    while h > 0:
        
        vf += g * delta_t
        distanciarecorrida += vf * delta_t
        h -= vf * delta_t
        tiempo += delta_t
        
        tiempos1.append(tiempo)
        velocidades1.append(vf)
        distancias1.append(distanciarecorrida)

    return tiempos1, velocidades1, distancias1

def confriccion(h, m, area):
    coefrozamiento = 0.1   # aquí es donde se cambia el coeficiente de rozamiento dependiendo del gusto
    delta_t = 0.001
    tiempo_total = 0
    velocidad = 0
    distancia = 0
    
    tiempos = []
    velocidades = []
    distancias = []
    
    while h > 0:
        a = g - (coefrozamiento * area * abs(velocidad) * velocidad) / m
        velocidad += a * delta_t
        distancia += velocidad * delta_t
        h -= velocidad * delta_t
        tiempo_total += delta_t
        
        tiempos.append(tiempo_total)
        velocidades.append(velocidad)
        distancias.append(distancia)

    return tiempos, velocidades, distancias

print("----------Resultados sin fricción-----------")
resultado1 = sinfriccion(h, m)
print("Tiempo total sin fricción:", resultado1[0][-1])
print("Velocidad final sin fricción:", resultado1[1][-1])
print("Distancia recorrida sin fricción:", resultado1[2][-1])

print("----------Resultados con fricción-----------")
resultado2 = confriccion(h, m, area)
print("Tiempo total con fricción:", resultado2[0][-1])
print("Velocidad final con fricción:", resultado2[1][-1])
print("Distancia recorrida con fricción:", resultado2[2][-1])

ti_final = perf_counter_ns()
tiempo_ejecucion = ti_final - ti_inicial

print("El tiempo de ejecución es (nanosegundos):", tiempo_ejecucion)

tiempos1 = resultado1[0]
velocidades1 = resultado1[1]
distancias1 = resultado1[2]

tiempos = resultado2[0]
velocidades = resultado2[1]
distancias = resultado2[2]


plt.figure(figsize=(12, 4))

plt.subplot(1, 2, 1)
plt.plot(tiempos1, velocidades1, label='Velocidad sin fricción')
plt.plot(tiempos, velocidades, label='Velocidad con fricción')
plt.xlabel('Tiempo (s)')
plt.ylabel('Velocidad (m/s)')
plt.legend()

plt.subplot(1, 2, 2)
plt.plot(tiempos1, distancias1, label='Distancia sin fricción')
plt.plot(tiempos, distancias, label='Distancia con fricción')
plt.xlabel('Tiempo (s)')
plt.ylabel('Distancia (m)')
plt.legend()

plt.show()
